#ifdef DS87C550
#include <reg550.h>
#else
#include <reg552.h>
#endif
#include <rtx51.h>
#include <stdio.h>
#include <stdlib.h>
#include <dsw.h>

#define	READ	1
#define	WRITE	0

#include <konstanty.inc>

#define	EEPROM_WAIT	10

extern void I2C_Start(void);
extern void I2C_Stop(void);
extern void Delay(unsigned char Dlzka);
extern void I2C_SendAddr(unsigned char Data);
extern void I2C_SendByte(unsigned char Data);
extern unsigned char I2C_Read(unsigned char);

void Write_Eprom_AT24C32(unsigned char Adresa, unsigned int EEprom_Addr, unsigned char Data)
{
 I2C_SendAddr(Adresa+WRITE);							//Pre pamati AT24C32 az AT24C64
 I2C_SendByte(high(EEprom_Addr));					//Pre AT24C08 tento riadok vymazat, je to 1kB pamat
 I2C_SendByte(low(EEprom_Addr));
 I2C_SendByte(Data);
 I2C_Stop();
 os_wait(K_TMO,EEPROM_WAIT,NULL);					//Cakam 10ms cez RTX51 Full
}

unsigned char Read_Eprom_AT24C32(unsigned char Adresa, unsigned int EEprom_Addr)
{
 unsigned char LSB;
 I2C_SendAddr(Adresa+WRITE);							//Pre pamati AT24C32 az AT24C64
 I2C_SendByte(high(EEprom_Addr));					//Pre AT24C08 tento riadok vymazat, je to 1kB pamat
 I2C_SendByte(low(EEprom_Addr));
 I2C_SendAddr(Adresa+READ);
 LSB=I2C_Read(0);
 I2C_Stop();
 return(LSB);
}
/*
unsigned char Current_Address_Read(unsigned char Adresa)
{
 unsigned char LSB;
 I2C_SendAddr(Adresa+READ);							//Pre pamati AT24C32 az AT24C64
 LSB=I2C_Read(0);
 I2C_Stop();
 return(LSB);
}
*/
/*
//#define SizeOfEpromBlock 16										//Velkost stranky 16Byte u AT24C04 pre blokovy prenos
#define SizeOfEpromBlock 32										//Velkost stranky 32Byte u AT24C32 pre blokovy prenos
//#define SizeOfEpromBlock 64										//Velkost stranky 64Byte u M24256 pre blokovy prenos

void Write_Block_Eprom_AT24C32(unsigned char Adresa, unsigned char EEprom_Page, unsigned char *Buffer)
{
 #ifndef RTX51
  unsigned char Counter=60;
 #endif
 unsigned char i;
 I2C_SendAddr(Adresa+WRITE);
 I2C_SendByte(high(EEprom_Page*SizeOfEpromBlock));				//Pre AT24C08 tento riadok vymazat, je to 1kB pamat
 I2C_SendByte(low(EEprom_Page*SizeOfEpromBlock));
 for(i=0x00; i<SizeOfEpromBlock; i++) 
  {
	 I2C_SendByte(Buffer[i]); 
   os_wait(K_TMO,EEPROM_WAIT,NULL);						//Cakam 10ms cez RTX51 Full
	} 
 I2C_Stop();
}

void Read_Block_Eprom_AT24C32(unsigned char Adresa, unsigned char EEprom_Page, unsigned char *Buffer)
{
 unsigned char i;
 I2C_SendAddr(Adresa+WRITE);
 I2C_SendByte(high(EEprom_Page*SizeOfEpromBlock));				//Pre AT24C08 vymazat, je to 1kB pamat
 I2C_SendByte(low(EEprom_Page*SizeOfEpromBlock));
 I2C_SendAddr(Adresa+READ);
 for(i=0x00; i<SizeOfEpromBlock; i++) 										//Prenasam 32Byte blok udajov s pACK
  {
	 switch(i)
	  {
		 case	(SizeOfEpromBlock-1)	:	Buffer[i]=I2C_Read(0); break;		// nACK pre ukoncenie
		 default										:	Buffer[i]=I2C_Read(1); break;		//pACK pre udrziavanie
	  }
	} 
 I2C_Stop();
}*/