;*****************************************
; I2C EEPROM (AT24C512) Byte Write
;*****************************************
	acall startc
	;Slave address
	mov a,#0A0H
	acall send
	;2-Byte Sub Address
	mov a,#00H
	acall send
	mov a,#00H
	acall send
	;Data
	mov a,#55H
	acall send
	acall stop
 
;*****************************************
; I2C EEPROM (AT24C512) 64-Byte Page Write
;*****************************************
	acall startc
	;Slave address
	mov a,#0A0H
	acall send
	;2-Byte Sub Address
	mov a,#00H
	acall send
	mov a,#00H
	acall send
	;Data
	mov r0,#64
again:
	mov a,r0
	acall send
	DJNZ r0, again
	acall stop
 
;*****************************************
; I2C EEPROM (AT24C512) Read Data
;*****************************************
	acall startc
	;Slave address
	mov a,#0A0H
	acall send
	;2-Byte Sub Address
	mov a,#00H
	acall send
	mov a,#00H
	acall send
	;Data
	acall rstart
	;Slave address writh Read bit
	mov a,#0A1H
	acall send
	;Read 10 Bytes
	mov r0, #9
	;Load read location (50H) in R1
	mov r1, #50H
read_more:
	acall read
	acall ack
	mov @r1, a
	inc r1
	djnz r0, read_more
	acall read
	acall nak
	mov @r1, a
	acall stop
	
;*****************************************
; I2C EEPROM (AT24C512) ACK Polling
;*****************************************
eeprom_not_ready:
	acall startc
	;Slave address
	mov a,#0A0H
	acall send
	acall stop
	jc eeprom_not_ready
	;When carry (ACK bit) is 0 it means EEPROM
	;Has acknowledged and its ready for next operation