******************************************
 * I2C EEPROM (AT24C512) Byte Write
 *****************************************/
	I2CStart();
	/* Slave address */
	I2CSend(0xA0);
	/* 2-Byte Sub Address */
	I2CSend(0x00);
	I2CSend(0x00);
	/* Data */
	I2CSend(0x55);
	I2CStop();
 
/******************************************
 * I2C EEPROM (AT24C512) 64-Byte Page Write
 *****************************************/
	I2CStart();
	/* Slave address */
	I2CSend(0xA0);
	/* 2-Byte Sub Address */
	I2CSend(0x00);
	I2CSend(0x00);
	/* Data 64 bytes */
	for (i = 0; i < 64; i++)
		I2CSend(i);
	I2CStop();
 
/******************************************
 * I2C EEPROM (AT24C512) Read Data
 *****************************************/
	I2CStart();
	/* Slave address */
	I2CSend(0xA0);
	/* 2-Byte Sub Address */
	I2CSend(0x00);
	I2CSend(0x00);
	I2CRestart();
	/* Slave address writh Read bit */
	I2CSend(0xA1);
	/* Read 10 Byte from EEPROM */
	for (i = 0; i < 9; i++) {
		array[i] = I2CRead();
		I2CAck();
	}
	array[i] = I2CRead();
	I2CNak();
	I2CStop();
	
/*****************************************
 * I2C EEPROM (AT24C512) ACK Polling
 *****************************************/
unsigned char eeprom_not_ready()
{
	unsigned char ack;
	
	I2CStart();
	/* Slave address */
	ack = I2CSend(0xA0);
	I2CStop();
	
	return ack;
}
 
/*
 * Example usage of eeprom_not_ready()
 *
 * while (eeprom_not_ready());
 * ... rest of code
 *
 */