#include <at89LP4052.h>
#include <stdio.h>				/* standard I/O .h-file               */
#include <ctype.h>				/* character functions                */
#include <string.h>				/* string and memory functions        */
#include <stdlib.h>
#include <rtx51tny.h>
#include <dsw.h>

#define AddrDS1631A	0x90

#include <adresy.inc>

enum {ON=0,OFF=1};

sbit	BackLight = P3^5;
sbit	Relay			=	P1^2;
sbit	Led				=	P1^3;

sbit	Plu	= P3^3;
sbit	Min	= P3^4;
sbit	Ent	=	P3^2;

#define	SYSTEM		0
#define	CLOCK			1
#define	SERIAL		2

extern char Get_Int_Temp(unsigned char);
extern unsigned char Riadok1,Riadok2;

extern void Init_Serial(void);
extern void LCD_Init(void);
extern void LCD_Home(void);
extern void LCD_Goto(unsigned char);
extern void LCD_Write_String(char*);

extern void Write_Eprom_DS1624(unsigned char, unsigned char, unsigned char);
extern unsigned char Read_Eprom_DS1624(unsigned char, unsigned char);

extern unsigned char Buffer[LCD_Size+1];
 
struct Hodiny
{
 unsigned char Hod,Min,Sek,Des,Tep;
};

struct Hodiny Cas = {6,15,0};

void Clock(void) _task_ CLOCK
{
 while(1)
  {
	 Led=~Led;
	 os_wait(K_IVL,100,NULL);
	 os_send_signal(SYSTEM);
	 if(++Cas.Des==10)
	  {
		 Cas.Des=0;
		 if(++Cas.Sek==60)
		  {
			 Cas.Sek=0;
			 if(++Cas.Min==60)
			  {
				 Cas.Min=0;
				 if(++Cas.Hod==24)
				  {
					 Cas.Hod=0;
					}
				}
			}
		}
	}	
}

code unsigned char Test[]="!!!>>>TEST<<<!!!";
//code unsigned char Logo[]=">>DSW Software<<";
 
void System(void) _task_ SYSTEM
{
 #ifdef DATE
   code unsigned char *SystemTime[]={__TIME__,__DATE__,__DATE2__,__C51__};
   sscanf(SystemTime[0],"%02bd:%02bd:%02bd",&Cas.Hod,&Cas.Min,&Cas.Sek);
 #endif
 LCD_Init();
 Init_Serial();
 Cas.Hod=Read_Eprom_DS1624(AddrDS1631A,0);
 Cas.Min=Read_Eprom_DS1624(AddrDS1631A,1);
 Cas.Tep=Read_Eprom_DS1624(AddrDS1631A,3);
//	Cas.Hod=Cas.Min=Cas.Sek=0;
 os_create_task(CLOCK);
 while(1)
  {
	 switch(os_wait(K_SIG,0xFF,NULL))
	  {
		 case	TMO_EVENT	:	sprintf(Buffer,"%s","Serial Error !!!");		//Neprisli asi 255ms ziadne udaje zo seriovej linky ..
											LCD_Goto(Riadok1);
											LCD_Write_String(Buffer);
											break;
		 case	SIG_EVENT	:	if((Plu==ON)&&(Ent==ON)) {while(Plu==ON) os_wait(K_TMO,100,NULL); if(++Cas.Min==60) Cas.Min=0; Write_Eprom_DS1624(AddrDS1631A,1,Cas.Min);}
											if((Min==ON)&&(Ent==ON)) {while(Min==ON) os_wait(K_TMO,100,NULL); if(++Cas.Hod==24) Cas.Hod=0; Write_Eprom_DS1624(AddrDS1631A,0,Cas.Hod);}
											if((Plu==ON)&&(Ent==OFF)) {Cas.Tep--; Write_Eprom_DS1624(AddrDS1631A,3,Cas.Tep);}
											if((Min==ON)&&(Ent==OFF)) {Cas.Tep++; Write_Eprom_DS1624(AddrDS1631A,3,Cas.Tep);}
											LCD_Goto(Riadok1);
											sprintf(Buffer,"Ziadana%c T=%bd%cC",(Cas.Tep>Get_Int_Temp(AddrDS1631A))?'!':' ',Cas.Tep,0xDF);
											LCD_Write_String(Buffer);
											LCD_Goto(Riadok2);
											sprintf(Buffer,"%02bd%c%02bd:%02bd T=%bd%cC",Cas.Hod,(Cas.Des>4)?' ':':',Cas.Min,Cas.Sek,Get_Int_Temp(AddrDS1631A),0xDF);
											LCD_Write_String(Buffer);
											if(Cas.Tep>Get_Int_Temp(AddrDS1631A)) Relay=ON; else Relay=OFF;
											break;
		}
	}
}