#include <reg552.h>
#include <stdio.h>
#include <stdlib.h>
#include <rtx51tny.h>
#include <pid_reg.h>

#define	Descriptor	5

#define	REGULATOR		0

xdata double xk,yk;
xdata pid_params *par;
xdata unsigned char malloc_mempool[sizeof(pid_params)+Descriptor]; //Musi tu byt 5+sizeof(pid_params) kvoli popisovacu mem_pool na kazdu mempool !!!

#define ADCS 0x08
#define ADCI 0x10
#define ADEX 0x20

int ADC(unsigned char Channel)		//Rutina trva 55us pri 18.432MHz
{
 register unsigned int x;
 ADCON=Channel;										//Vyber kanalu pre prevod 0..7
 ADCON|=(ADEX+ADCS);							//Spustim prevod, bolo tu ADCON|=ADEX+ADCS;
 while((ADCON&ADCI)==0x00);				//Cakam na ukoncenie prevodu
 ADCON^=ADCI;											//Nulujem priznak AD prevodnika
 x=ADCH*0x04;											//Normovanie na (int)
 switch(ADCON&(0x80+0x40))
  {
	 case	0x40	:	x+=0x01; break;
	 case	0x80	:	x+=0x02; break;
	 case	0xC0	:	x+=0x03; break;
	}
 return(x);
}

void Regulator(void) _task_ REGULATOR
{
 init_mempool(&malloc_mempool,sizeof(malloc_mempool));
 par=malloc(sizeof(pid_params));
 PWMP=0x20;
 par->kc=156.2;
 par->ti=230.0;
 par->td=57.5;
 par->ts=0.2;										//ts=T0 -> sampling period "Self-tuning PID Controllers 2004"
 par->k_lpf=par->td*0.1;				//k_lpf by malo byt Td/10, ale podla "Self-tuning PID Controllers 2004" Usually a = 10 is selected which means that the D-component filter has a time constant ten times smaller than the derivative time constant.
 init_pid2(par);
	while(1)
	{
		xk=(float)(100.0/1024.0)*ADC(0);
		pid_reg2(xk, &yk, 50.0, par, 1);
		PWM0=(unsigned char)yk;
		os_wait(K_IVL,20,NULL);
	}
}