#ifdef DS87C550
#include <reg550.h>
#else
#include <reg552.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <pidreg.h>
#include <rtx51.h>
#include <pktdrv.inc>
#include <dsw.h>

#include <konstanty.inc>

#define	REGK0					0		//Task musi mat cislo od 0..7 !!! nemenit lebo su naviazane na pole udajov !!!
#define	REGV0					1		//Task musi mat cislo od 0..7 !!! nemenit lebo su naviazane na pole udajov !!!
#define	REGK1					2		//Task musi mat cislo od 0..7 !!! nemenit lebo su naviazane na pole udajov !!!
#define	REGV1					3		//Task musi mat cislo od 0..7 !!! nemenit lebo su naviazane na pole udajov !!!
#define	TEMPERATURE		4		//Task musi mat cislo od 0..7 !!!
#define	SERIAL				5		//Task musi mat cislo od 0..7 !!!
#define	I2C_MODUL			6		//Task musi mat cislo od 0..7 !!!
#define	AD_CONVERT		7		//Task musi mat cislo od 0..7 !!! //task s prioritou 3 !!!
#define	SERVOK				8
#define	SERVOV				9
#define	CIRCULATEK		10
#define	CIRCULATEV		11
#define	CLOCK					12
#define	DISPLAY				13
#define	WDTIMER				14
#define	SYSTEM				15
/*
typedef union
{
	struct
	{
		unsigned char _ADCH:8;	//8..15 bit Value = 0x0FF..0x3F0 Uchovavaju najvyssie bity vysledku
		unsigned char _AADR:3;	//0..2 bit	Value = 0..7 a ich kombinacie
		unsigned char _ADCS:1;	//3..3 bit	Value = 0..1
		unsigned char _ADCI:1;	//4..4 bit	Value = 0..1
		unsigned char _ADEX:1;	//5..5 bit	Value = 0..1
	}
	b;
	unsigned char byte;
}
ADCON_t;
*/

typedef union
{
	struct
	{
		unsigned char _ADCH:8;	//8..15 bit Value = 0x0FF..0x3F0 Uchovavaju najvyssie bity vysledku
		unsigned char _AADR:3;	//0..2 bit	Value = 0..7 a ich kombinacie
		unsigned char _ADCS:1;	//3..3 bit	Value = 0..1
		unsigned char _ADCI:1;	//4..4 bit	Value = 0..1
		unsigned char _ADEX:1;	//5..5 bit	Value = 0..1
		unsigned char _ADCX:2;	//6..7 bit	Value = 0..3	Najvyssie bity schovavaju najnizsie bity vysledku
	}
	b;
	unsigned int word;
}
ADC_t;

//**************************************************************************************************************************************************************************************************************************************************
enum {OFF=0, ON=1};
enum {channel=0, tasknum=1};																//Nemenit poradnie, lebo je na tom zavisle vsetko v ADC prevodniku
enum {READ=0x80, WRITE=0x40, RESET=0x20, INIT=0x10};
enum {Zero=0, Min=-1, Max=+1, Deathtime=+30, Yes='Y', No='N'};
enum {ch0=0, ch1=1, ch2=2, ch3=3, ch4=4, ch5=5, ch6=6, ch7=7};
//**************************************************************************************************************************************************************************************************************************************************
#ifdef TABLE
extern code float TEMP_TAB[];																		//Ulozene teploty zodpovedajuce AD prevodu od 0..100C co je idealny pripad ...
extern code unsigned char PWM_TAB[];
#endif
extern void Init_Serial(void);
extern void Ekviterm(pid_Ekviterm*,unsigned char);
extern unsigned char Set_CRC(Packet51*,int);
extern unsigned char Check_CRC(Packet51*,int);
extern float Get_Float_Temp(unsigned char);
extern unsigned char Read_Eprom_AT24C32(unsigned char,unsigned int);
extern void Write_Eprom_AT24C32(unsigned char,unsigned int,unsigned char);
extern code pid_params pid[Numbers_Regulators];								//PID+ALE+TAK+PSD+DSP with LPF
extern code Logo;
extern void Reset(void);
extern int ADC(unsigned char);
//**************************************************************************************************************************************************************************************************************************************************
#define NumMemBlocks	2																				//Definujem [n] pamatovych blokov pre vysielaci a prijimaci buffer...
#define	SizeMemBlock	(sizeof(Packet51))
#define	SizeMemPool		(NumMemBlocks*(2+SizeMemBlock))					//(Header+sizeof(Packet51)*n)
//**************************************************************************************************************************************************************************************************************************************************
xdata Packet51 Packet;																				//Definoval som prazdny packet, naplnim ho v inom task-u, struktura nesmie byt optimalizovana kompilatorom ...
xdata Packet51 *TransmitMessage,*ReceivedMessage;							//Ukazovatel na prijate znaky z mailbox-u a na prijate znaky z RS232 a obsahujem prijaty packet z RS232 ...
xdata unsigned char MemoryPool[SizeMemPool];									//MemoryPool je niekedy lepsie definovat na pevnej adrese ale uVision robi problemy pri simulacii ...
xdata unsigned int *MessageToSend,*MessageToRecv;							//Rozne nadefinovane adresy buffer-ov vysielaneho a prijimaneho packet-u
//**************************************************************************************************************************************************************************************************************************************************
xdata Interval Cas;
xdata pid_Ekviterm Krivka[24];
xdata float xk[Numbers_Regulators];
xdata float yk[Numbers_Regulators];
xdata pid_params *par[Numbers_Regulators];
xdata pid_params *bak[Numbers_Regulators];
xdata var_params *var[Numbers_Regulators];
xdata lcd_screen *New_Screen,*Old_Screen;
xdata unsigned char MemoryPool_k[2*(Numbers_Regulators*(2+sizeof(pid_params)))];	//Parametre vsetkych regulatorov par[REGx]+var[REGx] a zalohy bak[REGx] ...
xdata unsigned char MemoryPool_v[2*(Numbers_Regulators*(2+sizeof(var_params)))];	//Parametre a premenne vsetkych regulatorov a zalohy ...
xdata unsigned char MemoryPool_s[2*(Numbers_Regulators*(2+sizeof(lcd_screen)))];	//Parametre a premenne vsetkych obrazoviek ...
//**************************************************************************************************************************************************************************************************************************************************
extern void Init_Serial(void);
extern void LCD_Init(void);
extern void LCD_Home(void);
extern void LCD_Goto(unsigned char);
extern void LCD_Write_String(char*);
extern void LCD_Line(lcd_screen*,unsigned char);
extern void LCD_Screen(lcd_screen*);
//**************************************************************************************************************************************************************************************************************************************************
extern void Vypocet_PID_Konstant(pid_params*,unsigned char,unsigned char,float,float,float);
//**************************************************************************************************************************************************************************************************************************************************
extern void init_pid_k0(pid_params*);
extern void init_pid_v0(pid_params*);
extern void init_ale_k0(pid_params*);
extern void init_ale_v0(pid_params*);
extern void init_tak_k0(pid_params*);
extern void init_tak_v0(pid_params*);
extern void init_psd_k0(pid_params*);
extern void init_psd_v0(pid_params*);
extern void init_dsp_k0(pid_params*);
extern void init_dsp_v0(pid_params*);
//**************************************************************************************************************************************************************************************************************************************************
extern void reg_pid_k0(float,float*,pid_params*,var_params*);	//PID with LPF
extern void reg_pid_v0(float,float*,pid_params*,var_params*);	//PID with LPF
extern void reg_ale_k0(float,float*,pid_params*,var_params*);	//Allen Bradley with LPF
extern void reg_ale_v0(float,float*,pid_params*,var_params*);	//Allen Bradley with LPF
extern void reg_tak_k0(float,float*,pid_params*,var_params*);	//Takahashi without LPF
extern void reg_tak_v0(float,float*,pid_params*,var_params*);	//Takahashi without LPF
extern void reg_psd_k0(float,float*,pid_params*,var_params*);	//Velocity PSD without LPF
extern void reg_psd_v0(float,float*,pid_params*,var_params*);	//Velocity PSD without LPF
extern void reg_dsp_k0(float,float*,pid_params*,var_params*);	//CMSIS DSP PID
extern void reg_dsp_v0(float,float*,pid_params*,var_params*);	//CMSIS DSP PID
//**************************************************************************************************************************************************************************************************************************************************
extern void init_pid_k1(pid_params*);
extern void init_pid_v1(pid_params*);
extern void init_ale_k1(pid_params*);
extern void init_ale_v1(pid_params*);
extern void init_tak_k1(pid_params*);
extern void init_tak_v1(pid_params*);
extern void init_psd_k1(pid_params*);
extern void init_psd_v1(pid_params*);
extern void init_dsp_k1(pid_params*);
extern void init_dsp_v1(pid_params*);
//**************************************************************************************************************************************************************************************************************************************************
extern void reg_pid_k1(float,float*,pid_params*,var_params*);	//PID with LPF
extern void reg_pid_v1(float,float*,pid_params*,var_params*);	//PID with LPF
extern void reg_ale_k1(float,float*,pid_params*,var_params*);	//Allen Bradley with LPF
extern void reg_ale_v1(float,float*,pid_params*,var_params*);	//Allen Bradley with LPF
extern void reg_tak_k1(float,float*,pid_params*,var_params*);	//Takahashi without LPF
extern void reg_tak_v1(float,float*,pid_params*,var_params*);	//Takahashi without LPF
extern void reg_psd_k1(float,float*,pid_params*,var_params*);	//Velocity PSD without LPF
extern void reg_psd_v1(float,float*,pid_params*,var_params*);	//Velocity PSD without LPF
extern void reg_dsp_k1(float,float*,pid_params*,var_params*);	//CMSIS DSP PID
extern void reg_dsp_v1(float,float*,pid_params*,var_params*);	//CMSIS DSP PID
//**************************************************************************************************************************************************************************************************************************************************
bdata DriverK,DriverV,Pumps;
//**************************************************************************************************************************************************************************************************************************************************
sbit Servo_k0_Min = DriverK^0;	sbit Servo_v0_Min = DriverV^0;	sbit Pump_k0 = Pumps^0;
sbit Servo_k1_Min = DriverK^1;	sbit Servo_v1_Min = DriverV^1;	sbit Pump_k1 = Pumps^1;
sbit Servo_k2_Min = DriverK^2;	sbit Servo_v2_Min = DriverV^2;	sbit Pump_k2 = Pumps^2;
sbit Servo_k3_Min = DriverK^3;	sbit Servo_v3_Min = DriverV^3;	sbit Pump_k3 = Pumps^3;
sbit Servo_k0_Max = DriverK^4;	sbit Servo_v0_Max = DriverV^4;	sbit Pump_v0 = Pumps^0;
sbit Servo_k1_Max = DriverK^5;	sbit Servo_v1_Max = DriverV^5;	sbit Pump_v1 = Pumps^1;
sbit Servo_k2_Max = DriverK^6;	sbit Servo_v2_Max = DriverV^6;	sbit Pump_v2 = Pumps^2;
sbit Servo_k3_Max = DriverK^7;	sbit Servo_v3_Max = DriverV^7;	sbit Pump_v3 = Pumps^3;
//**************************************************************************************************************************************************************************************************************************************************
#ifdef SIMUL
bit ADC_LED;
#endif
unsigned char PWM2,PWM3;
//**************************************************************************************************************************************************************************************************************************************************
#define ADCS 0x08
#define ADCI 0x10
#define ADEX 0x20
//**************************************************************************************************************************************************************************************************************************************************
enum {NOINTR_REQUEST=0, ADINTR_REQUEST=1, ATINTR_REQUEST=2};
//**************************************************************************************************************************************************************************************************************************************************
#ifdef	ADC_INTERRUPT
	#ifdef ATTACH_INTERRUPT
	xdata unsigned char Adc_Interrupt = ATINTR_REQUEST;											//Typ obsluhy prerusenia AD prevodnika, bez prerusenia je to 145us, klasicke prerusenie 99us alebo attachnute - je pomalsie cca. 460us  pri 18.432Mhz
	#else
	xdata unsigned char Adc_Interrupt = ADINTR_REQUEST;											//Typ obsluhy prerusenia AD prevodnika, bez prerusenia je to 145us, klasicke prerusenie 99us alebo attachnute - je pomalsie cca. 460us  pri 18.432Mhz
	void ADC_Int(void) interrupt 10	using 0																	//nesmie sa pouzit using 0 !?
	 {
	  xdata signed char RtxCompletion;
		RtxCompletion=isr_send_signal(AD_CONVERT);														//isr_send_signal() je asi 7x pomalsi ako os_send_signal() ???
		//RtxCompletion=os_send_signal(AD_CONVERT);
	 }
	#endif
#else
	xdata unsigned char Adc_Interrupt = NOINTR_REQUEST;											//Typ obsluhy prerusenia AD prevodnika, bez prerusenia je to 145us, klasicke prerusenie 99us alebo attachnute - je pomalsie cca. 460us  pri 18.432Mhz
#endif

#pragma REGISTERBANK(3)

void ADC_Converter(void) _task_ AD_CONVERT	_priority_ 3
{
 xdata signed char RtxCompletion;
 xdata unsigned int Message;
 xdata Frame *ReceivedFrameMsg;
 switch(Adc_Interrupt)
  {
	 case	ATINTR_REQUEST	:	RtxCompletion=os_attach_interrupt(10);	break;	//460us pri 18.432Mhz, Ak sa pouzije, musi sa void ADC_Int(void) interrupt 10 odstranit ...
	 case	ADINTR_REQUEST	:	RtxCompletion=os_enable_isr(10);	break;				//1000us pri 18.432Mhz s isr_send_signal() a 270us s os_send_signal() ...
	 case	NOINTR_REQUEST	:	break;																					//145us pri 18.432Mhz
	}
 for(;;)
  {
	 #ifdef ATTACH_INTERRUPT
	 switch(RtxCompletion=os_wait(K_SIG+K_INT+K_MBX+os_running_task_id(),WaitForEver,&Message))
	 #else
	 switch(RtxCompletion=os_wait(K_SIG+K_MBX+os_running_task_id(),WaitForEver,&Message))
	 #endif
	  {
		 case	MSG_EVENT	:	ReceivedFrameMsg=(Frame xdata*)Message;
											#ifdef SIMUL
											ADC_LED=ON;
											#endif
											switch(Adc_Interrupt)
											 {
											  case	ATINTR_REQUEST	:
												case	ADINTR_REQUEST	:	ADCON=ReceivedFrameMsg->Channel+ADCS+ADEX; 
																								//RtxCompletion=os_clear_signal(AD_CONVERT);
																								break;
												case	NOINTR_REQUEST	:	ReceivedFrameMsg->Value=ADC(ReceivedFrameMsg->Channel);
																								RtxCompletion=os_send_message(ReceivedFrameMsg->SrcTask,(unsigned int)ReceivedFrameMsg,WaitForAdc);
																								#ifdef SIMUL
																								ADC_LED=OFF;
																								#endif
																								break;
											 }
											break;
		 case	SIG_EVENT	:	
		 case	INT_EVENT	:	ADCON^=ADCI;
											ReceivedFrameMsg->Value=ADCH*0x04;
											switch(ADCON&(0x80|0x40))
											 {
											  case	0x40	:	ReceivedFrameMsg->Value+=0x01; break;
											  case	0x80	:	ReceivedFrameMsg->Value+=0x02; break;
											  case	0xC0	:	ReceivedFrameMsg->Value+=0x03; break;
											 }
											RtxCompletion=os_send_message(ReceivedFrameMsg->SrcTask,(unsigned int)ReceivedFrameMsg,WaitForAdc);
											#ifdef SIMUL
											ADC_LED=OFF;
											#endif
											break;
		}
  }
}

#pragma REGISTERBANK(2)

void Wdtimer(void) _task_ WDTIMER _priority_ 3			//Pri zapnuti Round Robin scheduling (vsetky tasky maju prioritu 0 -> time-slices) t.j. (RTX_TIMESHARING = 1) funguje tento task aj s prioritou 0, nemali by byt pouzite os_wait() !!!
{
 xdata signed char RtxCompletion;
 for(;;)
  {
	 switch(RtxCompletion=os_wait(K_TMO+K_SIG+K_INT,WaitFor050,NULL))
	  {
		 case	TMO_EVENT	:	
		 case	SIG_EVENT	:	Watchdog; break;	
		 case	INT_EVENT	:	Reset(); break;
		}
	}
}

#pragma REGISTERBANK(0)

void Clock(void) _task_ CLOCK _priority_ 1
{
 xdata signed char RtxCompletion;
 xdata unsigned char *Time[]={__TIME__,__DATE2__};
 sscanf(Time[0],"%02bd:%02bd:%02bd",&Cas.Hod,&Cas.Min,&Cas.Sek);
 sscanf(Time[1],"%02bd/%02bd/%02d",&Cas.Mes,&Cas.Den,&Cas.Rok);
 Cas.Rok+=2000;
 Cas.Des=0;
 for(;;)
  {
	 switch(RtxCompletion=os_wait(K_IVL+K_SIG,WaitFor250,NULL))
	  {
		 case	SIG_EVENT	:	break;
		 case	TMO_EVENT	:	if(++Cas.Des==WaitFor01s)
											 {
											  Cas.Des=0;
												if(++Cas.Sek==60)
												 {
												  Cas.Sek=0;
													/*
													Packet.Preamble=Token;
													Packet.Src=MyAddr51;
													Packet.Dst=0xFF;
													memset(&Packet.Data,(char)rand(),sizeof(Packet.Data));
													memcpy(MessageToSend,&Packet,sizeof(Packet51));												//Obsah Packet-u do odosielanej spravy ...
													RtxCompletion=os_send_message(SERIAL,(unsigned int)MessageToSend,20);	//Odoslem datovy packet na task SERIAL ...
													*/
													if(++Cas.Min==60)
													 {
													  Cas.Min=0;
														if(++Cas.Hod==24)
														 {
														  Cas.Hod=0;
															if(++Cas.Den==31)
															 {
															  Cas.Den=0;
															 }
														 }
													 }
												 }
											 }
											break;
		}	
	}
}

void Temperature(void) _task_ TEMPERATURE _priority_ 1
{
 xdata signed char RtxCompletion;
 xdata unsigned int Counter=WaitFor60s;
 xdata unsigned int Message;
 xdata Frame *ReceivedFrameMsg;
 //xdata Frame *TransmitFrameMsg4,*TransmitFrameMsg5;
 //xdata Frame Transmit_Frame4,Transmit_Frame5;
 //TransmitFrameMsg4=&Transmit_Frame4;
 //TransmitFrameMsg5=&Transmit_Frame5;
 xdata Frame *TransmitFrameMsg6,*TransmitFrameMsg7;
 xdata Frame Transmit_Frame6,Transmit_Frame7;
 TransmitFrameMsg6=&Transmit_Frame6;
 TransmitFrameMsg7=&Transmit_Frame7;
	for(;;)
	{
		switch(RtxCompletion=os_wait(K_TMO+K_SIG+K_INT+K_MBX+os_running_task_id(),WaitFor250,&Message))
		 {
		  case	SIG_EVENT	:	
			case	TMO_EVENT	:	switch(Counter)
												 {
													case	0						:	Counter=WaitFor60s;
													case	WaitFor60s	:	//TransmitFrameMsg4->Channel=ch4;
																							//TransmitFrameMsg4->DstTask=AD_CONVERT;
																							//TransmitFrameMsg4->SrcTask=os_running_task_id();
																							//RtxCompletion=os_send_message(TransmitFrameMsg4->DstTask,(unsigned int)TransmitFrameMsg4,WaitForAdc);
																							//TransmitFrameMsg5->Channel=ch5;
																							//TransmitFrameMsg5->DstTask=AD_CONVERT;
																							//TransmitFrameMsg5->SrcTask=os_running_task_id();
																							//RtxCompletion=os_send_message(TransmitFrameMsg5->DstTask,(unsigned int)TransmitFrameMsg5,WaitForAdc);
																							TransmitFrameMsg6->Channel=ch6;
																							TransmitFrameMsg6->DstTask=AD_CONVERT;
																							TransmitFrameMsg6->SrcTask=os_running_task_id();
																							RtxCompletion=os_send_message(TransmitFrameMsg6->DstTask,(unsigned int)TransmitFrameMsg6,WaitForAdc);
																							TransmitFrameMsg7->Channel=ch7;
																							TransmitFrameMsg7->DstTask=AD_CONVERT;
																							TransmitFrameMsg7->SrcTask=os_running_task_id();
																							RtxCompletion=os_send_message(TransmitFrameMsg7->DstTask,(unsigned int)TransmitFrameMsg7,WaitForAdc);
													default						:	Counter--;
																							break;
												 }
												break;
			case	MSG_EVENT	:	ReceivedFrameMsg=(Frame xdata*)Message;
												switch(ReceivedFrameMsg->Channel)
												 {
													case	ch4	:
																			break;
													case	ch5	:
																			break;
													case	ch6	:	
																			#ifdef TABLE
																			//TeplotaK1=(signed char)TEMP_TAB[Message.value];																																	//V Ekvitermickej tabulke su hodnoty ulozene s indexom 0 ako -50C a indexom 1023 ako +50C
																			par[REGK1]->Soll=Krivka[par[REGK1]->Ekviterm].t[(unsigned char)(TEMP_TAB[ReceivedFrameMsg->Value])];												//Externa teplota float s vyberom z tabulky
																			#else
																			//TeplotaK1=(signed char)(Step*Message.value);
																			par[REGK1]->Soll=(Krivka[par[REGK1]->Ekviterm].a)*(Step*ReceivedFrameMsg->Value)+(Krivka[par[REGK1]->Ekviterm].b);					//Externa teplota float s vypoctom podla vzorca
																			#endif
																			break;
													case	ch7	:	
																			#ifdef TABLE
																			//TeplotaK0=(signed char)TEMP_TAB[Message.value];																																	//V Ekvitermickej tabulke su hodnoty ulozene s indexom 0 ako -50C a indexom 1023 ako +50C
																			par[REGK0]->Soll=Krivka[par[REGK0]->Ekviterm].t[(unsigned char)(TEMP_TAB[ReceivedFrameMsg->Value])];												//Externa teplota float s vyberom z tabulky
																			#else
																			//TeplotaK0=(signed char)(Step*Message.value);
																			par[REGK0]->Soll=(Krivka[par[REGK0]->Ekviterm].a)*(Step*ReceivedFrameMsg->Value)+(Krivka[par[REGK0]->Ekviterm].b);					//Externa teplota float s vypoctom podla vzorca
																			#endif
																			break;
													default		:	break;						
												 }
												break;										
		 }
	}
}

void RegV1(void) _task_ REGV1 _priority_ 2
{
 xdata signed char RtxCompletion;
 //xdata t_rtx_onetasktab State_Task;
 xdata unsigned int Message;
 xdata Frame *ReceivedFrameMsg,*TransmitFrameMsg;
 xdata Frame Transmit_Frame;
 TransmitFrameMsg=&Transmit_Frame;
 RtxCompletion=os_send_signal(REGV1);
 for(;;)
	{
		switch(RtxCompletion=os_wait(K_TMO+K_SIG+K_INT+K_MBX+os_running_task_id(),par[REGV1]->os_wait_ts_ticks,&Message))
		 {
		  case	TMO_EVENT	:	TransmitFrameMsg->Channel=ch3;
												TransmitFrameMsg->DstTask=AD_CONVERT;
												TransmitFrameMsg->SrcTask=os_running_task_id();
												RtxCompletion=os_send_message(TransmitFrameMsg->DstTask,(unsigned int)TransmitFrameMsg,WaitForAdc);
												break;
			case	MSG_EVENT	:	ReceivedFrameMsg=(Frame xdata*)Message;
												#ifdef TABLE
												xk[REGV1]=TEMP_TAB[ReceivedFrameMsg->Value];
												#else
												xk[REGV1]=(float)(100.0*Step)*ReceivedFrameMsg->Value;												//Skalujem na 0% az 100%
												#endif
												switch(par[REGV1]->pid_model)
												 {
												  default		:																																	//ak nie je zvoleny ziaden regulator, tak musi byt spusteny defaultne vypnuty PID a to je tu s parametrom par[REGV1]->pid_model=0
													case	PID	:	reg_pid_v1(xk[REGV1],&yk[REGV1],par[REGV1],var[REGV1]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
													case	ALE	:	reg_ale_v1(xk[REGV1],&yk[REGV1],par[REGV1],var[REGV1]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
													case	TAK	:	reg_tak_v1(xk[REGV1],&yk[REGV1],par[REGV1],var[REGV1]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
													case	PSD	:	reg_psd_v1(xk[REGV1],&yk[REGV1],par[REGV1],var[REGV1]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
													case	DSP	:	reg_dsp_v1(xk[REGV1],&yk[REGV1],par[REGV1],var[REGV1]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
												 }
												if(xk[REGV1]>(par[REGV1]->Tlimit)) {yk[REGV1]=var[REGV1]->yk_1=var[REGV1]->yk_2; /*var[REGV1]->ek_1=var[REGV1]->ek_2;*/}	//Obmedzenie na teplotu Tlimit !!!
												PWM3=(unsigned char)(yk[REGV1]);
												par[REGV1]->SetPosition=(unsigned int)(yk[REGV1]*RegVSrvMax/10);
												/*RtxCompletion=os_check_task(CIRCULATEV,(t_rtx_onetasktab xdata*)&State_Task);
												switch(State_Task.state)
												 {
												  case	K_READY		:	
													case	K_RUNNING	:	
													case	K_BLOCKED	:	RtxCompletion=os_send_signal(CIRCULATEV);	break;	//Udrziava zapnute cerpadla pokial idu regulatory
													case	K_DELETED	:	RtxCompletion=os_create_task(CIRCULATEV);	break;	//Idu regulatory tak zapnem obehove cerpadla
												 }*/
												break;
			case	SIG_EVENT	:	switch(par[REGV1]->pid_model)
													{
													 default	:
													 case	NOR	:																														//ak nie je zvoleny ziaden regulator, tak musi byt spusteny defaultne vypnuty PID a to je tu s parametrom TypRegulatora=0
													 case	PID	:	init_pid_v1(par[REGV1]); break;
													 case	ALE	:	init_ale_v1(par[REGV1]); break;
													 case	TAK	:	init_tak_v1(par[REGV1]); break;
													 case	PSD	:	init_psd_v1(par[REGV1]); break;
													 case	DSP	:	init_dsp_v1(par[REGV1]); break;
													}
												break;												
		 }
	}
}

void RegK1(void) _task_ REGK1 _priority_ 2
{
 xdata signed char RtxCompletion;
 //xdata t_rtx_onetasktab State_Task;
 xdata unsigned int Message;
 xdata Frame *ReceivedFrameMsg,*TransmitFrameMsg;
 xdata Frame Transmit_Frame;
 TransmitFrameMsg=&Transmit_Frame;
 RtxCompletion=os_send_signal(REGK1);
 for(;;)
	{
		switch(RtxCompletion=os_wait(K_TMO+K_SIG+K_INT+K_MBX+os_running_task_id(),par[REGK1]->os_wait_ts_ticks,&Message))
		 {
		  case	TMO_EVENT	:	TransmitFrameMsg->Channel=ch2;
												TransmitFrameMsg->DstTask=AD_CONVERT;
												TransmitFrameMsg->SrcTask=os_running_task_id();
												RtxCompletion=os_send_message(TransmitFrameMsg->DstTask,(unsigned int)TransmitFrameMsg,WaitForAdc);
												break;
			case	MSG_EVENT	:	ReceivedFrameMsg=(Frame xdata*)Message;
												#ifdef TABLE
												xk[REGK1]=TEMP_TAB[ReceivedFrameMsg->Value];
												#else
												xk[REGK1]=(float)(100.0*Step)*ReceivedFrameMsg->Value;												//Skalujem na 0% az 100%
												#endif
												switch(par[REGK1]->pid_model)
												 {
												  default		:																																	//ak nie je zvoleny ziaden regulator, tak musi byt spusteny defaultne vypnuty PID a to je tu s parametrom par[REGK1]->pid_model=0
													case	PID	:	reg_pid_k1(xk[REGK1],&yk[REGK1],par[REGK1],var[REGK1]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
													case	ALE	:	reg_ale_k1(xk[REGK1],&yk[REGK1],par[REGK1],var[REGK1]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
													case	TAK	:	reg_tak_k1(xk[REGK1],&yk[REGK1],par[REGK1],var[REGK1]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
													case	PSD	:	reg_psd_k1(xk[REGK1],&yk[REGK1],par[REGK1],var[REGK1]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
													case	DSP	:	reg_dsp_k1(xk[REGK1],&yk[REGK1],par[REGK1],var[REGK1]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
												 }
												if(xk[REGK1]>(par[REGK1]->Tlimit)) {yk[REGK1]=var[REGK1]->yk_1=var[REGK1]->yk_2; /*var[REGK1]->ek_1=var[REGK1]->ek_2;*/}	//Obmedzenie na teplotu Tlimit !!!
												PWM2=(unsigned char)(yk[REGK1]);
												par[REGK1]->SetPosition=(unsigned int)(yk[REGK1]*RegKSrvMax/10);
												/*RtxCompletion=os_check_task(CIRCULATEK,(t_rtx_onetasktab xdata*)&State_Task);
												switch(State_Task.state)
												 {
												  case	K_READY		:	
													case	K_RUNNING	:	
													case	K_BLOCKED	:	RtxCompletion=os_send_signal(CIRCULATEK);	break;	//Udrziava zapnute cerpadla pokial idu regulatory
													case	K_DELETED	:	RtxCompletion=os_create_task(CIRCULATEK);	break;	//Idu regulatory tak zapnem obehove cerpadla
												 }*/
												break;
			case	SIG_EVENT	:	switch(par[REGK1]->pid_model)
												{
												 default	:
												 case	NOR	:	//ak nie je zvoleny ziaden regulator, tak musi byt spusteny defaultne vypnuty PID a to je tu s parametrom TypRegulatora=0
												 case	PID	:	init_pid_k1(par[REGK1]); break;
												 case	ALE	:	init_ale_k1(par[REGK1]); break;
												 case	TAK	:	init_tak_k1(par[REGK1]); break;
												 case	PSD	:	init_psd_k1(par[REGK1]); break;
												 case	DSP	:	init_dsp_k1(par[REGK1]); break;
												}
												break;
		 }
	}
}

void RegV0(void) _task_ REGV0 _priority_ 2
{
 xdata signed char RtxCompletion;
 xdata t_rtx_onetasktab State_Task;
 xdata unsigned int Message;
 xdata Frame *ReceivedFrameMsg,*TransmitFrameMsg;
 xdata Frame Transmit_Frame;
 TransmitFrameMsg=&Transmit_Frame;
 RtxCompletion=os_send_signal(REGV0);
 for(;;)
	{
		switch(RtxCompletion=os_wait(K_TMO+K_SIG+K_INT+K_MBX+os_running_task_id(),par[REGV0]->os_wait_ts_ticks,&Message))
		 {
		  case	TMO_EVENT	:	TransmitFrameMsg->Channel=ch1;
												TransmitFrameMsg->DstTask=AD_CONVERT;
												TransmitFrameMsg->SrcTask=os_running_task_id();
												RtxCompletion=os_send_message(TransmitFrameMsg->DstTask,(unsigned int)TransmitFrameMsg,WaitForAdc);
												break;
			case	MSG_EVENT	:	ReceivedFrameMsg=(Frame xdata*)Message;
												#ifdef TABLE
												xk[REGV0]=TEMP_TAB[ReceivedFrameMsg->Value];
												#else
												xk[REGV0]=(float)(100.0*Step)*ReceivedFrameMsg->Value;												//Skalujem na 0% az 100%
												#endif
												switch(par[REGV0]->pid_model)
												 {
												  default		:																																	//ak nie je zvoleny ziaden regulator, tak musi byt spusteny defaultne vypnuty PID a to je tu s parametrom par[REGV0]->pid_model=0
													case	PID	:	reg_pid_v0(xk[REGV0],&yk[REGV0],par[REGV0],var[REGV0]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
													case	ALE	:	reg_ale_v0(xk[REGV0],&yk[REGV0],par[REGV0],var[REGV0]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
													case	TAK	:	reg_tak_v0(xk[REGV0],&yk[REGV0],par[REGV0],var[REGV0]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
													case	PSD	:	reg_psd_v0(xk[REGV0],&yk[REGV0],par[REGV0],var[REGV0]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
													case	DSP	:	reg_dsp_v0(xk[REGV0],&yk[REGV0],par[REGV0],var[REGV0]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
												 }
												if(xk[REGV0]>(par[REGV0]->Tlimit)) {yk[REGV0]=var[REGV0]->yk_1=var[REGV0]->yk_2; /*var[REGV0]->ek_1=var[REGV0]->ek_2;*/}	//Obmedzenie na teplotu Tlimit !!!
												PWM1=(unsigned char)(yk[REGV0]);
												par[REGV0]->SetPosition=(unsigned int)(yk[REGV0]*RegVSrvMax/10);
												RtxCompletion=os_check_task(CIRCULATEV,(t_rtx_onetasktab xdata*)&State_Task);
												switch(State_Task.state)
												 {
												  case	K_READY		:	
													case	K_RUNNING	:	
													case	K_BLOCKED	:	RtxCompletion=os_send_signal(CIRCULATEV);	break;	//Udrziava zapnute cerpadla pokial idu regulatory
													case	K_DELETED	:	RtxCompletion=os_create_task(CIRCULATEV);	break;	//Idu regulatory tak zapnem obehove cerpadla
												 }
												break;
			case	SIG_EVENT	:	switch(par[REGV0]->pid_model)
												{
												 default	:
												 case	NOR	:																															//ak nie je zvoleny ziaden regulator, tak musi byt spusteny defaultne vypnuty PID a to je tu s parametrom TypRegulatora=0
												 case	PID	:	init_pid_v0(par[REGV0]); break;
												 case	ALE	:	init_ale_v0(par[REGV0]); break;
												 case	TAK	:	init_tak_v0(par[REGV0]); break;
												 case	PSD	:	init_psd_v0(par[REGV0]); break;
												 case	DSP	:	init_dsp_v0(par[REGV0]); break;
												}
												break;												
		 }
	}
}

void RegK0(void) _task_ REGK0 _priority_ 2
{
 xdata signed char RtxCompletion;
 xdata t_rtx_onetasktab State_Task;
 xdata unsigned int Message;
 xdata Frame *ReceivedFrameMsg,*TransmitFrameMsg;
 xdata Frame Transmit_Frame;
 TransmitFrameMsg=&Transmit_Frame;
 RtxCompletion=os_send_signal(REGK0);
 for(;;)
	{
		switch(RtxCompletion=os_wait(K_TMO+K_SIG+K_INT+K_MBX+os_running_task_id(),par[REGK0]->os_wait_ts_ticks,&Message))
		 {
		  case	TMO_EVENT	:	TransmitFrameMsg->Channel=ch0;
												TransmitFrameMsg->DstTask=AD_CONVERT;
												TransmitFrameMsg->SrcTask=os_running_task_id();
												RtxCompletion=os_send_message(TransmitFrameMsg->DstTask,(unsigned int)TransmitFrameMsg,WaitForAdc);
												break;
			case	MSG_EVENT	:	ReceivedFrameMsg=(Frame xdata*)Message;
												#ifdef TABLE
												xk[REGK0]=TEMP_TAB[ReceivedFrameMsg->Value];
												#else
												xk[REGK0]=(float)(100.0*Step)*ReceivedFrameMsg->Value;												//Skalujem na 0% az 100%
												#endif
												switch(par[REGK0]->pid_model)
												 {
												  default		:																																	//ak nie je zvoleny ziaden regulator, tak musi byt spusteny defaultne vypnuty PID a to je tu s parametrom TypRegulatora=0
													case	PID	:	reg_pid_k0(xk[REGK0],&yk[REGK0],par[REGK0],var[REGK0]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
													case	ALE	:	reg_ale_k0(xk[REGK0],&yk[REGK0],par[REGK0],var[REGK0]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
													case	TAK	:	reg_tak_k0(xk[REGK0],&yk[REGK0],par[REGK0],var[REGK0]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
													case	PSD	:	reg_psd_k0(xk[REGK0],&yk[REGK0],par[REGK0],var[REGK0]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
													case	DSP	:	reg_dsp_k0(xk[REGK0],&yk[REGK0],par[REGK0],var[REGK0]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
												 }
												if(xk[REGK0]>(par[REGK0]->Tlimit)) {yk[REGK0]=var[REGK0]->yk_1=var[REGK0]->yk_2; /*var[REGK0]->ek_1=var[REGK0]->ek_2;*/}	//Obmedzenie na teplotu Tlimit !!!
												PWM0=(unsigned char)(yk[REGK0]);
												par[REGK0]->SetPosition=(unsigned int)(yk[REGK0]*RegKSrvMax/10);
												RtxCompletion=os_check_task(CIRCULATEK,(t_rtx_onetasktab xdata*)&State_Task);
												switch(State_Task.state)
												 {
												  case	K_READY		:	
													case	K_RUNNING	:	
													case	K_BLOCKED	:	RtxCompletion=os_send_signal(CIRCULATEK);	break;	//Udrziava zapnute cerpadla pokial idu regulatory
													case	K_DELETED	:	RtxCompletion=os_create_task(CIRCULATEK);	break;	//Idu regulatory tak zapnem obehove cerpadla
												 }	
												break;
			case	SIG_EVENT	:	switch(par[REGK0]->pid_model)
												{
												 default	:
												 case	NOR	:																															//ak nie je zvoleny ziaden regulator, tak musi byt spusteny defaultne vypnuty PID a to je tu s parametrom TypRegulatora=0
												 case	PID	:	init_pid_k0(par[REGK0]); break;
												 case	ALE	:	init_ale_k0(par[REGK0]); break;
												 case	TAK	:	init_tak_k0(par[REGK0]); break;
												 case	PSD	:	init_psd_k0(par[REGK0]); break;
												 case	DSP	:	init_dsp_k0(par[REGK0]); break;
												}
												break;
		 }
	}
}

void ServoK(void) _task_ SERVOK _priority_ 0
{
 xdata signed char RtxCompletion,Actual0=OFF,Actual1=OFF,Actual2=OFF,Actual3=OFF;
 #ifdef SAFE
 xdata t_rtx_onetasktab State_Task;
 #endif
 TCON|=0x01;																		//Nastavim citlivost na hranu prerusenia /EXT0 a /EXT1
 RtxCompletion=os_attach_interrupt(0);
 for(;;)
  {
	 Pump_k0=par[REGK0]->Pump;
	 Pump_k1=par[REGK1]->Pump;
	 switch(RtxCompletion=os_wait(K_IVL+K_SIG+K_INT,WaitFor100,NULL))
	  {
		 case	TMO_EVENT	:	par[REGK0]->dPosition=par[REGK0]->SetPosition-par[REGK0]->ActualPosition;
											switch(Actual0=memcmp(&par[REGK0]->SetPosition,&par[REGK0]->ActualPosition,sizeof(par[REGK0]->ActualPosition)))
											 {
											  case	Zero	:	if(Actual0!=Actual1) {Servo_k0_Max=Servo_k0_Min=OFF; RtxCompletion=os_wait(K_TMO,Deathtime,NULL);}
																			break;
												case	Max		:	if(Actual0!=Actual1) {Servo_k0_Min=OFF; RtxCompletion=os_wait(K_TMO,Deathtime,NULL); Servo_k0_Max=ON;}
																			par[REGK0]->ActualPosition++;
																			break;
												case	Min		:	if(Actual0!=Actual1) {Servo_k0_Max=OFF; RtxCompletion=os_wait(K_TMO,Deathtime,NULL); Servo_k0_Min=ON;}
																			par[REGK0]->ActualPosition--;
																			break;
											 }
											Actual1=Actual0;
											par[REGK1]->dPosition=par[REGK1]->SetPosition-par[REGK1]->ActualPosition;
											switch(Actual2=memcmp(&par[REGK1]->SetPosition,&par[REGK1]->ActualPosition,sizeof(par[REGK1]->ActualPosition)))
											 {
											  case	Zero	:	if(Actual2!=Actual3) {Servo_k1_Max=Servo_k1_Min=OFF; RtxCompletion=os_wait(K_TMO,Deathtime,NULL);}
																			break;
												case	Max		:	if(Actual2!=Actual3) {Servo_k1_Min=OFF; RtxCompletion=os_wait(K_TMO,Deathtime,NULL); Servo_k1_Max=ON;}
																			par[REGK1]->ActualPosition++;
																			break;
												case	Min		:	if(Actual2!=Actual3) {Servo_k1_Max=OFF; RtxCompletion=os_wait(K_TMO,Deathtime,NULL); Servo_k1_Min=ON;}
																			par[REGK1]->ActualPosition--;
																			break;
											 }
											Actual3=Actual2;
											break;
		 case	SIG_EVENT	:	//Servo_k0_Max=ON;
											break;
		 case	INT_EVENT	:	
											#ifdef SAFE
											do {RtxCompletion=os_check_task(REGK0,(t_rtx_onetasktab xdata*)&State_Task);} while(State_Task.state&K_READY);
											#endif
											RtxCompletion=os_delete_task(REGK0);						//Obsluha havarijneho stavu, odstavim task a zavriem servoventily ....
											par[REGK0]->SetPosition=par[REGK0]->Servo_Min;
											break;											
		 default				:	break;
		} 
	}
}

void ServoV(void) _task_ SERVOV _priority_ 0
{
 xdata signed char RtxCompletion,Actual0=OFF,Actual1=OFF,Actual2=OFF,Actual3=OFF;
 #ifdef SAFE
 xdata t_rtx_onetasktab State_Task;
 #endif
 TCON|=0x04;																		//Nastavim citlivost na hranu prerusenia /EXT0 a /EXT1
 RtxCompletion=os_attach_interrupt(1);
 for(;;)
  {
	 Pump_v0=par[REGV0]->Pump;
	 Pump_v1=par[REGV1]->Pump;
	 switch(RtxCompletion=os_wait(K_IVL+K_SIG+K_INT,WaitFor100,NULL))
	  {
		 case	TMO_EVENT	:	par[REGV0]->dPosition=par[REGV0]->SetPosition-par[REGV0]->ActualPosition;
											switch(Actual0=memcmp(&par[REGV0]->SetPosition,&par[REGV0]->ActualPosition,sizeof(par[REGV0]->ActualPosition)))
											 {
											  case	Zero	:	if(Actual0!=Actual1) {Servo_v0_Max=Servo_v0_Min=OFF; RtxCompletion=os_wait(K_TMO,Deathtime,NULL);}
																			break;
												case	Max		:	if(Actual0!=Actual1) {Servo_v0_Min=OFF; RtxCompletion=os_wait(K_TMO,Deathtime,NULL); Servo_v0_Max=ON;}
																			par[REGV0]->ActualPosition++;
																			break;
												case	Min		:	if(Actual0!=Actual1) {Servo_v0_Max=OFF; RtxCompletion=os_wait(K_TMO,Deathtime,NULL); Servo_v0_Min=ON;}
																			par[REGV0]->ActualPosition--;
																			break;
											 }
											Actual1=Actual0;
											par[REGV1]->dPosition=par[REGV1]->SetPosition-par[REGV1]->ActualPosition;
											switch(Actual2=memcmp(&par[REGV1]->SetPosition,&par[REGV1]->ActualPosition,sizeof(par[REGV1]->ActualPosition)))
											 {
											  case	Zero	:	if(Actual2!=Actual3) {Servo_v1_Max=Servo_v1_Min=OFF; RtxCompletion=os_wait(K_TMO,Deathtime,NULL);}
																			break;
												case	Max		:	if(Actual2!=Actual3) {Servo_v1_Min=OFF; RtxCompletion=os_wait(K_TMO,Deathtime,NULL); Servo_v1_Max=ON;}
																			par[REGV1]->ActualPosition++;
																			break;
												case	Min		:	if(Actual2!=Actual3) {Servo_v1_Max=OFF; RtxCompletion=os_wait(K_TMO,Deathtime,NULL); Servo_v1_Min=ON;}
																			par[REGV1]->ActualPosition--;
																			break;
											 }
											Actual3=Actual2;
											break;
		 case	SIG_EVENT	:	//Servo_v0_Max=ON;
											break;
		 case	INT_EVENT	:	
											#ifdef SAFE
											do {RtxCompletion=os_check_task(REGV0,(t_rtx_onetasktab xdata*)&State_Task);} while(State_Task.state&K_READY);
											#endif
											RtxCompletion=os_delete_task(REGV0);						//Obsluha havarijneho stavu, odstavim task a zavriem servoventily ....
											par[REGV0]->SetPosition=par[REGV0]->Servo_Min;
											break;											
		 default				:	break;
		}
	}
}

void Circulate_PumpK(void) _task_ CIRCULATEK _priority_ 0
{
 xdata signed char RtxCompletion;
 xdata t_rtx_onetasktab State_Task;
 xdata unsigned int Counter=WaitFor10m;
 for(;;)
  {
	 switch(RtxCompletion=os_wait(K_TMO+K_SIG,WaitFor250,NULL))
	  {
		 case	SIG_EVENT	:	Counter=WaitFor10m;
											break;
		 case	TMO_EVENT	:	switch(Counter)
											 {
												case	0						:	Counter=WaitFor10m;
																						RtxCompletion=os_check_task(REGK0,(t_rtx_onetasktab xdata*)&State_Task);
																						switch(State_Task.state)
																						 {
																						  case	K_READY		:	
																							case	K_RUNNING	:	
																							case	K_BLOCKED	: RtxCompletion=os_delete_task(CIRCULATEK);	//Preslo 10 minut pre obehove cerpadlo, vypnem ho ....	
																							case	K_DELETED	:	break;
																						 }
																						//RtxCompletion=os_check_tasks((t_rtx_alltasktab xdata*)&State_Tasks);
												default						:	Counter--;
																						break;
											 }
											break;
		}
	}
}

void Circulate_PumpV(void) _task_ CIRCULATEV _priority_ 0
{
 xdata signed char RtxCompletion;
 xdata t_rtx_onetasktab State_Task;
 xdata unsigned int Counter=WaitFor10m;
 for(;;)
  {
	 switch(RtxCompletion=os_wait(K_TMO+K_SIG,WaitFor250,NULL))
	  {
		 case	SIG_EVENT	:	Counter=WaitFor10m;
											break;
		 case	TMO_EVENT	:	switch(Counter)
											 {
												case	0						:	Counter=WaitFor10m;
																						RtxCompletion=os_check_task(REGV0,(t_rtx_onetasktab xdata*)&State_Task);
																						switch(State_Task.state)
																						 {
																						  case	K_READY		:	
																							case	K_RUNNING	:	
																							case	K_BLOCKED	:	RtxCompletion=os_delete_task(CIRCULATEV);	//Preslo 10 minut pre obehove cerpadlo, vypnem ho ....
																							case	K_DELETED	:	break;
																						 }
																						//RtxCompletion=os_check_tasks((t_rtx_alltasktab xdata*)&State_Tasks);
												default						: Counter--;
																						break;
											 }
											break;
		}
	}
}


void Serial(void) _task_ SERIAL _priority_ 0				//Skontrolovat prijem a vysielanie
{
 xdata signed char RtxCompletion;
 xdata unsigned int cnt_in,cnt_out,MBX_Message;
 xdata unsigned char Znak;
 Init_Serial();
 RtxCompletion=os_attach_interrupt(4);
 for(;;)
 {
	switch(RtxCompletion=os_wait(K_SIG+K_INT+K_MBX+os_running_task_id(),WaitForEver,&MBX_Message))
	{
	 case	SIG_EVENT	:	break;
	 case	TMO_EVENT	:	break;
	 case	INT_EVENT	:	switch(S0CON&(RXD|TXD))
										 {
											default		:	break;
											case	RXD	:	RI=0;
																	switch(Znak=S0BUF)
																	 {
																		case	Token	:	cnt_in=0x0000; memset(ReceivedMessage,0x00,sizeof(Packet51));						//Skontrolovat ...	
																		default			:	((unsigned char xdata*)ReceivedMessage)[cnt_in++]=Znak; break;
																	 }
																	switch(cnt_in)
																	 {
																	  case	(sizeof(Packet51)-1)	:	if(ReceivedMessage->Crc==Check_CRC(ReceivedMessage,sizeof(Packet51))) 
																																	 {
																																		memcpy(&Packet,ReceivedMessage,sizeof(Packet51));			//Skontrolovat ...
																																		cnt_in=0x0000;
																																	 }	
																																	break;
																		default											:	break;
																	 }
																	break;
											case	TXD	:	TI=0;
																	switch(cnt_out)
																	 {
																	  case	(sizeof(Packet51)-1)	:	cnt_out=0x0000;		//Skontrolovat !!!
																																	break;
																		default											:	S0BUF=((unsigned char xdata*)TransmitMessage)[cnt_out++]; 
																																	break;
																	 }
																	break;
										 }
										break;
	 case	MSG_EVENT	:	cnt_out=0x0000;
										TransmitMessage=(Packet51 xdata*)MBX_Message;
										Packet.Crc=Set_CRC(&Packet,sizeof(Packet51));
										TransmitMessage->Crc=Check_CRC(TransmitMessage,sizeof(Packet51));
										TI=1;
										break;
	}
 }
}


void Display(void) _task_ DISPLAY	_priority_ 0
{
 xdata signed char RtxCompletion;
 xdata unsigned int Counter=WaitFor01s;
 LCD_Init();
 for(;;)
  {
	 switch(RtxCompletion=os_wait(K_TMO+K_SIG,WaitFor250,NULL))
	  {
		 case	TMO_EVENT	:	switch(Counter)
											 {
												case	0						:	Counter=WaitFor01s;
												case	WaitFor01s	:	sprintf(New_Screen->lcd_line[Line1]," Diversant Software \r\n");
																						sprintf(New_Screen->lcd_line[Line2],"      (c)%04d       \r\n",Cas.Rok);	//
																						sprintf(New_Screen->lcd_line[Line3],"     %02bd.%02bd.%04d\r\n",Cas.Den,Cas.Mes,Cas.Rok);
																						sprintf(New_Screen->lcd_line[Line4],"      %02bd:%02bd:%02bd\r\n",Cas.Hod,Cas.Min,Cas.Sek);
																						//sprintf(New_Screen->lcd_line[Line4],"       %02bd:%02bd\r\n",Cas.Hod,Cas.Min);
																						switch(memcmp(New_Screen,Old_Screen,sizeof(lcd_screen)))			//Zaznamenal som nejaku zmenu v obrazovke a tak vypisem cely display znova ...
																						 {
																							case	0	:	break;
																							default	:	memcpy(Old_Screen,New_Screen,sizeof(lcd_screen));	//Skopirujem nove hodnoty do starych ...
																												LCD_Screen(New_Screen);														//Na LCD display poslem cely obsah struktury New_Screen ... Pozor, po vypisani restazca na dislpaly sa vymazu \r\n\0 a preto musi byt kopirovanie urovene ako prve a potom vypisanie na display ...
																												break;
																						 }
												default						:	Counter--;
																						break;
											 }
											break;
		 case	SIG_EVENT	:	break;	
		}
	}
}

void I2C_Modul(void) _task_ I2C_MODUL _priority_ 0
{
 xdata signed char RtxCompletion;
 #ifdef SAFE
 xdata t_rtx_onetasktab State_Task;
 #endif
 xdata unsigned int Adresa,Message,Teplota,Counter=WaitFor60s;
 xdata Frame *ReceivedFrameMsg,*TransmitFrameMsg;
 xdata Frame Transmit_Frame;
 xdata unsigned char *ptr,i;
 TransmitFrameMsg=&Transmit_Frame;
 ptr=(char*)&Logo;									//Adresa mojho popisneho Loga programu ...		//P1=Logo;
 ptr=(unsigned char xdata*)&pid;		//Adresa na ulozene paramete regulatora vo FLASH
 for(;;)
  {
	 switch(RtxCompletion=os_wait(K_SIG+K_INT+K_MBX+os_running_task_id(),WaitFor250,&Message))
	  {
		 case	SIG_EVENT	:
		 case	INT_EVENT	:
		 case	TMO_EVENT	:	switch(Counter)
											 {
												case	0						:	Counter=WaitFor60s;
												case	WaitFor60s	:	Teplota=(int)Get_Float_Temp(AddrDS1624A+0x00); 				//Interna teplota elektroniky merana kazdych 60s na kanali 0x00 ...
												default						:	Counter--;
																						break;
											 }
											break;
		 case	MSG_EVENT	:	ReceivedFrameMsg=(Frame xdata*)Message;
											TransmitFrameMsg->DstTask=ReceivedFrameMsg->SrcTask;
											TransmitFrameMsg->SrcTask=os_running_task_id();
											switch(ReceivedFrameMsg->DstAddr)
											 {
												case	AddrDS1624A		:	RtxCompletion=os_send_message(TransmitFrameMsg->DstTask,(TransmitFrameMsg->Value=(int)TransmitFrameMsg->FloatValue=Get_Float_Temp(AddrDS1624A+ReceivedFrameMsg->Channel)),WaitFor020);		//Vratim (int) vysledok zdrojovemu tasku ...
																							break;
												case	AddrDS1807A		:	
																							break;
												case	AddrAT24c32		:	switch(ReceivedFrameMsg->Action&(READ|WRITE|RESET|INIT))
																							 {
																								case	READ	:	Adresa=0x0000;
																															#ifdef SAFE
																															do {RtxCompletion=os_check_task(I2C_MODUL,(t_rtx_onetasktab xdata*)&State_Task);} while(State_Task.state&K_BLOCKED);
																															#endif
																															ptr=memcpy(bak[REGK0],par[REGK0],sizeof(pid_params));
																															for(i=0x00; i<sizeof(pid_params); i++) ptr[i]=Read_Eprom_AT24C32(AddrAT24c32,Adresa+i);
																															Adresa+=sizeof(pid_params);
																															#ifdef SAFE
																															do {RtxCompletion=os_check_task(I2C_MODUL,(t_rtx_onetasktab xdata*)&State_Task);} while(State_Task.state&K_BLOCKED);
																															#endif
																															ptr=memcpy(bak[REGV0],par[REGV0],sizeof(pid_params));
																															for(i=0x00; i<sizeof(pid_params); i++) ptr[i]=Read_Eprom_AT24C32(AddrAT24c32,Adresa+i);
																															Adresa+=sizeof(pid_params);
																															#ifdef SAFE
																															do {RtxCompletion=os_check_task(I2C_MODUL,(t_rtx_onetasktab xdata*)&State_Task);} while(State_Task.state&K_BLOCKED);
																															#endif
																															ptr=memcpy(bak[REGK1],par[REGK1],sizeof(pid_params));
																															for(i=0x00; i<sizeof(pid_params); i++) ptr[i]=Read_Eprom_AT24C32(AddrAT24c32,Adresa+i);																
																															Adresa+=sizeof(pid_params);
																															#ifdef SAFE
																															do {RtxCompletion=os_check_task(I2C_MODUL,(t_rtx_onetasktab xdata*)&State_Task);} while(State_Task.state&K_BLOCKED);
																															#endif
																															ptr=memcpy(bak[REGV1],par[REGV1],sizeof(pid_params));
																															for(i=0x00; i<sizeof(pid_params); i++) ptr[i]=Read_Eprom_AT24C32(AddrAT24c32,Adresa+i);
																															Adresa+=sizeof(pid_params);
																															RtxCompletion=os_delete_task(REGK0); Wait;
																															RtxCompletion=os_delete_task(REGV0); Wait;
																															RtxCompletion=os_delete_task(REGK1); Wait;
																															RtxCompletion=os_delete_task(REGV1); Wait;
																															RtxCompletion=os_delete_task(SERVOK); Wait;
																															RtxCompletion=os_delete_task(SERVOV); Wait;
																															RtxCompletion=os_delete_task(CIRCULATEK); Wait;
																															RtxCompletion=os_delete_task(CIRCULATEV); Wait;
																															ptr=memcpy(par[REGK0],bak[REGK0],sizeof(pid_params));		//Prekopirujem udaje precitane z I2C_MODUL a zapisem ich do prislusneho regulatora
																															ptr=memcpy(par[REGV0],bak[REGV0],sizeof(pid_params));		//Prekopirujem udaje precitane z I2C_MODUL a zapisem ich do prislusneho regulatora
																															ptr=memcpy(par[REGK1],bak[REGK1],sizeof(pid_params));		//Prekopirujem udaje precitane z I2C_MODUL a zapisem ich do prislusneho regulatora
																															ptr=memcpy(par[REGV1],bak[REGV1],sizeof(pid_params));		//Prekopirujem udaje precitane z I2C_MODUL a zapisem ich do prislusneho regulatora
																															RtxCompletion=os_create_task(REGK0); Wait;
																															RtxCompletion=os_create_task(REGV0); Wait;
																															RtxCompletion=os_create_task(REGK1); Wait;
																															RtxCompletion=os_create_task(REGV1); Wait;
																															RtxCompletion=os_create_task(SERVOK); Wait;
																															RtxCompletion=os_create_task(SERVOV); Wait;
																															RtxCompletion=os_create_task(CIRCULATEK); Wait;
																															RtxCompletion=os_create_task(CIRCULATEV); Wait;
																															ReceivedFrameMsg->Action^=READ;
																															RtxCompletion=os_send_signal(SYSTEM);			//Hodnoty z I2C_MODUL su nacitane a tak spustim regulatory a vypnem task SYSTEM ....
																															break;
																								case	WRITE	:	Adresa=0x0000;
																															RtxCompletion=os_delete_task(REGK0); Wait;
																															RtxCompletion=os_delete_task(REGV0); Wait;
																															RtxCompletion=os_delete_task(REGK1); Wait;
																															RtxCompletion=os_delete_task(REGV1); Wait;
																															RtxCompletion=os_delete_task(SERVOK); Wait;
																															RtxCompletion=os_delete_task(SERVOV); Wait;
																															RtxCompletion=os_delete_task(CIRCULATEK); Wait;
																															RtxCompletion=os_delete_task(CIRCULATEV); Wait;												
																															#ifdef SAFE
																															do {RtxCompletion=os_check_task(I2C_MODUL,(t_rtx_onetasktab xdata*)&State_Task);} while(State_Task.state&K_BLOCKED);
																															#endif
																															ptr=memcpy(bak[REGK0],par[REGK0],sizeof(pid_params));
																															for(i=0x00; i<sizeof(pid_params); i++)
																															 {
																																#ifdef SAFE
																																do {RtxCompletion=os_check_task(I2C_MODUL,(t_rtx_onetasktab xdata*)&State_Task);} while(State_Task.state&K_BLOCKED);
																																#endif
																																Write_Eprom_AT24C32(AddrAT24c32,Adresa+i,ptr[i]);
																															 }
																															Adresa+=sizeof(pid_params); 
																															#ifdef SAFE
																															do {RtxCompletion=os_check_task(I2C_MODUL,(t_rtx_onetasktab xdata*)&State_Task);} while(State_Task.state&K_BLOCKED);
																															#endif
																															ptr=memcpy(bak[REGV0],par[REGV0],sizeof(pid_params));
																															for(i=0x00; i<sizeof(pid_params); i++)
																															 {
																																#ifdef SAFE
																																do {RtxCompletion=os_check_task(I2C_MODUL,(t_rtx_onetasktab xdata*)&State_Task);} while(State_Task.state&K_BLOCKED);
																																#endif
																																Write_Eprom_AT24C32(AddrAT24c32,Adresa+i,ptr[i]);
																															 }
																															Adresa+=sizeof(pid_params); 
																															#ifdef SAFE
																															do {RtxCompletion=os_check_task(I2C_MODUL,(t_rtx_onetasktab xdata*)&State_Task);} while(State_Task.state&K_BLOCKED);
																															#endif
																															ptr=memcpy(bak[REGK1],par[REGK1],sizeof(pid_params));
																															for(i=0x00; i<sizeof(pid_params); i++)
																															 {
																																#ifdef SAFE
																																do {RtxCompletion=os_check_task(I2C_MODUL,(t_rtx_onetasktab xdata*)&State_Task);} while(State_Task.state&K_BLOCKED);
																																#endif
																																Write_Eprom_AT24C32(AddrAT24c32,Adresa+i,ptr[i]);
																															 }
																															Adresa+=sizeof(pid_params); 
																															#ifdef SAFE
																															do {RtxCompletion=os_check_task(I2C_MODUL,(t_rtx_onetasktab xdata*)&State_Task);} while(State_Task.state&K_BLOCKED);
																															#endif
																															ptr=memcpy(bak[REGV1],par[REGV1],sizeof(pid_params));
																															for(i=0x00; i<sizeof(pid_params); i++)
																															 {
																																#ifdef SAFE
																																do {RtxCompletion=os_check_task(I2C_MODUL,(t_rtx_onetasktab xdata*)&State_Task);} while(State_Task.state&K_BLOCKED);
																																#endif
																																Write_Eprom_AT24C32(AddrAT24c32,Adresa+i,ptr[i]);
																															 }
																															memset(TransmitFrameMsg,0x00,sizeof(Frame));
																															TransmitFrameMsg->DstTask=ReceivedFrameMsg->SrcTask;
																															TransmitFrameMsg->SrcTask=os_running_task_id();
																															TransmitFrameMsg->DstAddr=AddrAT24c32;
																															TransmitFrameMsg->Action=READ;																															
																															RtxCompletion=os_send_message(TransmitFrameMsg->SrcTask,(unsigned int)TransmitFrameMsg,WaitFor020);			//Testovaci rezim najprv zapise do I2C_MODUL a potom odtial cita, inac to nefunguje !!!
																															break;
																								case	RESET	:	ReceivedFrameMsg->Action^=RESET;
																															Reset();													
																															//((void (code*) (void)) 0x0000) ();
																															break;
																								case	INIT	:	ReceivedFrameMsg->Action^=INIT;
																															break;
																								default			:	ReceivedFrameMsg->Action&=~(READ|WRITE|RESET|INIT); break;												
																							 }
																							break;
											 }											
											break;
		}	
	}
}

void System(void) _task_ SYSTEM _priority_ 0
{
 xdata signed char RtxCompletion;
 #ifdef SIMUL
 xdata unsigned char *ptr;
 #endif
 xdata unsigned char i;
 xdata Frame *TransmitFrameMsg;
 xdata Frame Transmit_Frame;
 TransmitFrameMsg=&Transmit_Frame;
 RtxCompletion=os_set_slice(1536);
 RtxCompletion=os_create_task(WDTIMER);
 DriverK=DriverV=Pumps=OFF;
 PWMP=0x20;
 
 for(i=0; i<24; i++) Ekviterm(&Krivka[i],i);																							//Ekvitermicka krivka -> Krivka[0].t[0]=0;
 
 RtxCompletion=os_create_pool(sizeof(Packet51),MemoryPool,sizeof(MemoryPool));						//Buffer pre strukturu typu Packet51
 RtxCompletion=os_create_pool(sizeof(pid_params),MemoryPool_k,sizeof(MemoryPool_k));			//Buffer pre strukturu parametrov regulatora - program
 RtxCompletion=os_create_pool(sizeof(var_params),MemoryPool_v,sizeof(MemoryPool_v));			//Buffer pre strukturu parametrov regulatora - premenne
 RtxCompletion=os_create_pool(sizeof(lcd_screen),MemoryPool_s,sizeof(MemoryPool_s));			//Buffer pre strukturu obrazoviek - premenne
 
 MessageToSend=(unsigned int xdata*)TransmitMessage=os_get_block(sizeof(Packet51));				//Odosielaci Buffer pre RS232
 MessageToRecv=(unsigned int xdata*)ReceivedMessage=os_get_block(sizeof(Packet51));				//Prijimaci Buffer pre RS232
 
 par[REGK0]=os_get_block(sizeof(pid_params)); memset(par[REGK0],NULL,sizeof(pid_params));		//Pridelim dynamicku pamat pre struktury a inicializujem ju ...
 par[REGV0]=os_get_block(sizeof(pid_params)); memset(par[REGV0],NULL,sizeof(pid_params));		//Pridelim dynamicku pamat pre struktury a inicializujem ju ...
 bak[REGK0]=os_get_block(sizeof(pid_params)); memset(par[REGK0],NULL,sizeof(pid_params));		//Pridelim dynamicku pamat pre struktury a inicializujem ju ...
 bak[REGV0]=os_get_block(sizeof(pid_params)); memset(par[REGV0],NULL,sizeof(pid_params));		//Pridelim dynamicku pamat pre struktury a inicializujem ju ...
 var[REGK0]=os_get_block(sizeof(var_params)); memset(var[REGK0],NULL,sizeof(var_params));		//Pridelim dynamicku pamat pre struktury a inicializujem ju ...
 var[REGV0]=os_get_block(sizeof(var_params)); memset(var[REGV0],NULL,sizeof(var_params));		//Pridelim dynamicku pamat pre struktury a inicializujem ju ...
 
 par[REGK1]=os_get_block(sizeof(pid_params)); memset(par[REGK1],NULL,sizeof(pid_params));		//Pridelim dynamicku pamat pre struktury a inicializujem ju ...
 par[REGV1]=os_get_block(sizeof(pid_params)); memset(par[REGV1],NULL,sizeof(pid_params));		//Pridelim dynamicku pamat pre struktury a inicializujem ju ...
 bak[REGK1]=os_get_block(sizeof(pid_params)); memset(par[REGK1],NULL,sizeof(pid_params));		//Pridelim dynamicku pamat pre struktury a inicializujem ju ...
 bak[REGV1]=os_get_block(sizeof(pid_params)); memset(par[REGV1],NULL,sizeof(pid_params));		//Pridelim dynamicku pamat pre struktury a inicializujem ju ...
 var[REGK1]=os_get_block(sizeof(var_params)); memset(var[REGK1],NULL,sizeof(var_params));		//Pridelim dynamicku pamat pre struktury a inicializujem ju ...
 var[REGV1]=os_get_block(sizeof(var_params)); memset(var[REGV1],NULL,sizeof(var_params));		//Pridelim dynamicku pamat pre struktury a inicializujem ju ...
 
 New_Screen=os_get_block(sizeof(lcd_screen));	memset(New_Screen,NULL,sizeof(lcd_screen));		//Pridelim dynamicku pamat pre struktury a inicializujem ju ...
 Old_Screen=os_get_block(sizeof(lcd_screen));	memset(Old_Screen,NULL,sizeof(lcd_screen));		//Pridelim dynamicku pamat pre struktury a inicializujem ju ...
 
 #ifdef SIMUL
 ptr=memcpy(par[REGK0],&pid[REGK0],sizeof(pid_params));	//Nacitaj factory hodnoty z pamati programu ...
 ptr=memcpy(par[REGV0],&pid[REGV0],sizeof(pid_params));	//Nacitaj factory hodnoty z pamati programu ...
 ptr=memcpy(par[REGK1],&pid[REGK1],sizeof(pid_params));	//Nacitaj factory hodnoty z pamati programu ...
 ptr=memcpy(par[REGV1],&pid[REGV1],sizeof(pid_params));	//Nacitaj factory hodnoty z pamati programu ...
 #endif

 Vypocet_PID_Konstant(par[REGK0],ITA,PID_Type,+115.0,+14691.0,+1.689);
 Vypocet_PID_Konstant(par[REGK1],ITA,PID_Type,+115.0,+14691.0,+1.689);
 Vypocet_PID_Konstant(par[REGV0],ITA,PID_Type,+115.0,+14691.0,+1.689);
 Vypocet_PID_Konstant(par[REGV1],ITA,PID_Type,+115.0,+14691.0,+1.689);
 Vypocet_PID_Konstant(par[REGK0],COH,PID_Type,+115.0,+14691.0,+1.689);
 Vypocet_PID_Konstant(par[REGK1],COH,PID_Type,+115.0,+14691.0,+1.689);
 Vypocet_PID_Konstant(par[REGV0],COH,PID_Type,+115.0,+14691.0,+1.689);
 Vypocet_PID_Konstant(par[REGV1],COH,PID_Type,+115.0,+14691.0,+1.689);

 Vypocet_PID_Konstant(par[REGK0],ZIE,PID_Type,+115.0,+14691.0,+0.000);	//Vypocet nepotrebuje _Khlt a _Thlt co sa zistuje komplikovanejsie ...
 Vypocet_PID_Konstant(par[REGK1],ZIE,PID_Type,+115.0,+14691.0,+0.000);	//Vypocet nepotrebuje _Khlt a _Thlt co sa zistuje komplikovanejsie ...
 Vypocet_PID_Konstant(par[REGV0],ZIE,PID_Type,+115.0,+14691.0,+0.000);	//Vypocet nepotrebuje _Khlt a _Thlt co sa zistuje komplikovanejsie ...
 Vypocet_PID_Konstant(par[REGV1],ZIE,PID_Type,+115.0,+14691.0,+0.000);	//Vypocet nepotrebuje _Khlt a _Thlt co sa zistuje komplikovanejsie ... 

 par[REGK0]->pid_model=PID;																							//Vyber konkretneho typu regulatora PID-LPF, Allen Bradley-LPF, Takahashi bez filtracie D zlozky - LPF, PSD bez LPF ...
 par[REGV0]->pid_model=PID;																							//Vyber konkretneho typu regulatora PID-LPF, Allen Bradley-LPF, Takahashi bez filtracie D zlozky - LPF, PSD bez LPF ...
 par[REGK1]->pid_model=PID;																							//Vyber konkretneho typu regulatora PID-LPF, Allen Bradley-LPF, Takahashi bez filtracie D zlozky - LPF, PSD bez LPF ... 
 par[REGV1]->pid_model=PID;																							//Vyber konkretneho typu regulatora PID-LPF, Allen Bradley-LPF, Takahashi bez filtracie D zlozky - LPF, PSD bez LPF ...
 
 par[REGK0]->Ekviterm=13;																								//Nastavim vykurovaciu krivku, musi byt nastavena pred spustenim vsetkych ostatnych taskov, inac to nefunguje ...
 par[REGK1]->Ekviterm=13;																								//Nastavim vykurovaciu krivku, musi byt nastavena pred spustenim vsetkych ostatnych taskov, inac to nefunguje ...
 
 RtxCompletion=os_create_task(AD_CONVERT); Wait;
 RtxCompletion=os_create_task(DISPLAY); Wait;
 RtxCompletion=os_create_task(TEMPERATURE); Wait;
 RtxCompletion=os_create_task(I2C_MODUL); Wait;
 RtxCompletion=os_create_task(CLOCK); Wait;
 RtxCompletion=os_create_task(SERIAL); Wait;
 
 TransmitFrameMsg->SrcTask=os_running_task_id();
 TransmitFrameMsg->DstTask=I2C_MODUL;
 TransmitFrameMsg->DstAddr=AddrAT24c32;
 #ifdef SIMUL
 TransmitFrameMsg->Action=WRITE;
 #else
 TransmitFrameMsg->Action=READ;
 #endif
 RtxCompletion=os_send_message(I2C_MODUL,(unsigned int)TransmitFrameMsg,WaitFor020);			//Testovaci rezim najprv zapise do I2C_MODUL a potom odtial cita, inac to nefunguje !!!
 for(;;)
  {
	 switch(RtxCompletion=os_wait(K_SIG+K_INT,WaitForEver,NULL))					//Cakam pokial nenacitam udaje z I2C_MODUL a ukoncim task SYSTEM ...
	  {
		 case	SIG_EVENT	:	
		 case	TMO_EVENT	:	
		 case	INT_EVENT	:	RtxCompletion=os_delete_task(SYSTEM);
											break;
		}
	}
}

xdata ADC_t Nastav;

void main(void)
{
 Nastav.b._AADR=7;
 Nastav.b._ADCS=1;
 Nastav.b._ADCI=1;
 Nastav.b._ADEX=1;
 Nastav.b._ADCX=3;
 Nastav.b._ADCH=0x3F;
 //Nastav.word=0x3Fxx;
 os_start_system(SYSTEM);
}