#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <pidreg.h>

//																										                      dead-time         Thlt     Gain Khlt
void Vypocet_PID_Konstant(pid_params *p, unsigned char _Metoda, unsigned char _Type, float _Tu, float _Thlt, float _Khlt)
{
 switch(_Metoda)
  {
	 default		:
	 case	ZIE		:	switch(_Type)
										 {
											case	P_Type		:	p->kc=(_Thlt/_Tu);													//Vypocet nepotrebuje _Khlt a _Thlt co sa zistuje komplikovanejsie ...
																				p->ti=+0.00;																//Open-Loop
																				p->td=+0.00;
																				break;
											case	PI_Type		:	p->kc=+0.90*(_Thlt/_Tu);										//Vypocet nepotrebuje _Khlt a _Thlt co sa zistuje komplikovanejsie ...
																				p->ti=+3.50*_Tu;														//Open-Loop
																				p->td=+0.00;
																				break;
											case	PD_Type		:	p->kc=+1.20*(_Thlt/_Tu);										//Vypocet nepotrebuje _Khlt a _Thlt co sa zistuje komplikovanejsie ...
																				p->ti=+0.00;																//Open-Loop
																				p->td=+0.25*_Tu;
																				break;
											default					:
											case	PID_Type	:	p->kc=+1.25*(_Thlt/_Tu);										//Vypocet nepotrebuje _Khlt a _Thlt co sa zistuje komplikovanejsie ...
																				p->ti=+2.00*_Tu;														//Open-Loop
																				p->td=+0.50*_Tu;
																				break;
										 }
										break;
		case	COH		:	switch(_Type)
										 {
											case	PI_Type		:	p->kc=(_Thlt/(_Khlt*_Tu))*((_Tu/(12*_Thlt))+(+9.00/+10.00));		//Closed-Loop
																				p->ti=(_Tu*((+30.0*_Thlt+3.00*_Tu)/(+9.00*_Thlt+20.00*_Tu)));
																				p->td=+0.00;
																				break;
											default					:
											case	PID_Type	:	p->kc=(_Thlt/(_Khlt*_Tu))*((_Tu/(4*_Thlt))+(+4.00/+3.00));			//Closed-Loop
																				p->ti=(_Tu*((+32.0*_Thlt+6.00*_Tu)/(+13.00*_Thlt+8.00*_Tu)));
																				p->td=(_Tu*((+4.00*_Thlt)/(+2.00*_Tu+11.00*_Thlt)));
																				break;
											}									
										break;
		case	ITA	:	switch(_Type)
										 {
											case	PI_Type		:	p->kc=(+0.859/_Khlt)*pow((_Tu/_Thlt),-0.977);										//Closed-Loop
																				p->ti=(_Thlt/+0.674)*pow((_Tu/_Thlt),+0.680);
																				p->td=+0.00;
																				break;
											default					:
											case	PID_Type	:	p->kc=(+1.357/_Khlt)*pow((_Tu/_Thlt),-0.947);										//Closed-Loop
																				p->ti=(_Thlt/+0.842)*pow((_Tu/_Thlt),+0.738);
																				p->td=(+0.381*_Thlt)*pow((_Tu/_Thlt),+0.995);
																				break;
										 }
										 break;
	}
}