#ifdef DS87C550
#include <reg550.h>
#else
#include <reg552.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pidreg.h>

code pid_params pid[Numbers_Regulators] = 																													//Factory settings - tovarenske nastavenie regulatora
{
 {
	 RKkc, 																																														// Controller gain from Dialog Box
	 RKti, 																																														// Time-constant for I action from Dialog Box
	 RKtd, 																																														// Time-constant for D action from Dialog Box
	 RKts, 																																														// Sample time [sec.] from Dialog Box, //ts=T0 -> sampling period "Self-tuning PID Controllers 2004"
	 RKk_lpf,																																													// Time constant [sec.] for LPF filter, //k_lpf by malo byt Td/10, ale podla "Self-tuning PID Controllers 2004" Usually a = 10 is selected which means that the D-component filter has a time constant ten times smaller than the derivative time constant.
	 RKkc*(+1.0+(RKts/(2.0*RKti))+(2.0*RKtd/alfak)), 																									// k0 value for PID controller
	 RKkc*(RKts*RKts/RKti-4.0*RKk_lpf-4.0*RKtd)/alfak, 																								// k1 value for PID controller
	 ((2.0*RKk_lpf-RKts+RKts*RKts/(2.0*RKti))+(2.0*RKtd-RKk_lpf*RKts/RKti))*(RKkc/alfak),							// k2 value for PID controller - Bola tu chyba !!! p->k2 += 2.0 * p->ti - p->k_lpf * p->ts / p->ti;
	 0.0,																																															// k3 value for PID controller
	 4.0*RKk_lpf/alfak,																																								// value for LPF filter
	 (RKts-2.0*RKk_lpf)/alfak, 																																				// value for LPF filter
	 RKts*1000,																																												// ticks for timer
	 1,																																																// PID Controller type [0..3]
	 0.0, 																																														// debug
	 0.0, 																																														// debug
	 0.0, 																																														// debug
	 0.0,																																															// Temporary value for WinDup
   50.0,																																														// Ziadana hodnota teploty ...
	 0,0,0,																																														// SetPosition,ActualPosition,dPosition;
   RegKSrvMin,RegKSrvMax,0,RegKSrvHyster,																														
	 25,23,2,50,65,95,																																								// Tkomfort,Tutlm,deltaT,Tmin,Tmax,Tlimit;
	 AntiWin,																																													// Obmedzenie narastu vystupnej hodnoty regulatora v % pri prepnuti ziadanej hodnoty ....
	 10,																																															// Ekvitermicka - vykurovacia krivka ...
 }
 ,
 {
	 RVkc, 																																														// Controller gain from Dialog Box
	 RVti, 																																														// Time-constant for I action from Dialog Box
	 RVtd, 																																														// Time-constant for D action from Dialog Box
	 RVts, 																																														// Sample time [sec.] from Dialog Box, //ts=T0 -> sampling period "Self-tuning PID Controllers 2004"
	 RVk_lpf,																																													// Time constant [sec.] for LPF filter, //k_lpf by malo byt Td/10, ale podla "Self-tuning PID Controllers 2004" Usually a = 10 is selected which means that the D-component filter has a time constant ten times smaller than the derivative time constant.
	 RVkc*(+1.0+(RVts/(2.0*RVti))+(2.0*RVtd/alfav)), 																									// k0 value for PID controller
	 RVkc*(RVts*RVts/RVti-4.0*RVk_lpf-4.0*RVtd)/alfav, 																								// k1 value for PID controller
	 ((2.0*RVk_lpf-RVts+RVts*RVts/(2.0*RVti))+(2.0*RVtd-RVk_lpf*RVts/RVti))*(RVkc/alfav),							// k2 value for PID controller - Bola tu chyba !!! p->k2 += 2.0 * p->ti - p->k_lpf * p->ts / p->ti;
	 0.0,																																															// k3 value for PID controller
	 4.0*RVk_lpf/alfav,																																								// value for LPF filter
	 (RVts-2.0*RVk_lpf)/alfav, 																																				// value for LPF filter
	 RVts*1000,																																												// ticks for timer
	 1,																																																// PID Controller type [0..3]
	 0.0, 																																														// debug
	 0.0, 																																														// debug
	 0.0, 																																														// debug
	 0.0,																																															// Temporary value for WinDup
   50.0,																																														// Ziadana hodnota teploty ...
	 0,0,0,																																														// SetPosition,ActualPosition,dPosition;
   RegVSrvMin,RegVSrvMax,0,RegVSrvHyster,																														
	 25,23,2,50,65,95,																																								// Tkomfort,Tutlm,deltaT,Tmin,Tmax,Tlimit;
	 AntiWin,																																													// Obmedzenie narastu vystupnej hodnoty regulatora v % pri prepnuti ziadanej hodnoty ....
	 0,																																																// Ekvitermicka - vykurovacia krivka ...
 }
 ,
  {
	 RKkc, 																																														// Controller gain from Dialog Box
	 RKti, 																																														// Time-constant for I action from Dialog Box
	 RKtd, 																																														// Time-constant for D action from Dialog Box
	 RKts, 																																														// Sample time [sec.] from Dialog Box, //ts=T0 -> sampling period "Self-tuning PID Controllers 2004"
	 RKk_lpf,																																													// Time constant [sec.] for LPF filter, //k_lpf by malo byt Td/10, ale podla "Self-tuning PID Controllers 2004" Usually a = 10 is selected which means that the D-component filter has a time constant ten times smaller than the derivative time constant.
	 RKkc*(+1.0+(RKts/(2.0*RKti))+(2.0*RKtd/alfak)), 																									// k0 value for PID controller
	 RKkc*(RKts*RKts/RKti-4.0*RKk_lpf-4.0*RKtd)/alfak, 																								// k1 value for PID controller
	 ((2.0*RKk_lpf-RKts+RKts*RKts/(2.0*RKti))+(2.0*RKtd-RKk_lpf*RKts/RKti))*(RKkc/alfak),							// k2 value for PID controller - Bola tu chyba !!! p->k2 += 2.0 * p->ti - p->k_lpf * p->ts / p->ti;
	 0.0,																																															// k3 value for PID controller
	 4.0*RKk_lpf/alfak,																																								// value for LPF filter
	 (RKts-2.0*RKk_lpf)/alfak, 																																				// value for LPF filter
	 RKts*1000,																																												// ticks for timer
	 1,																																																// PID Controller type [0..3]
	 0.0, 																																														// debug
	 0.0, 																																														// debug
	 0.0, 																																														// debug
	 0.0,																																															// Temporary value for WinDup
   50.0,																																														// Ziadana hodnota teploty ...
	 0,0,0,																																														// SetPosition,ActualPosition,dPosition;
   RegKSrvMin,RegKSrvMax,0,RegKSrvHyster,																														
	 25,23,2,50,65,95,																																								// Tkomfort,Tutlm,deltaT,Tmin,Tmax,Tlimit;
	 AntiWin,																																													// Obmedzenie narastu vystupnej hodnoty regulatora v % pri prepnuti ziadanej hodnoty ....
	 10,																																															// Ekvitermicka - vykurovacia krivka ...
 }
 ,
 {
	 RVkc, 																																														// Controller gain from Dialog Box
	 RVti, 																																														// Time-constant for I action from Dialog Box
	 RVtd, 																																														// Time-constant for D action from Dialog Box
	 RVts, 																																														// Sample time [sec.] from Dialog Box, //ts=T0 -> sampling period "Self-tuning PID Controllers 2004"
	 RVk_lpf,																																													// Time constant [sec.] for LPF filter, //k_lpf by malo byt Td/10, ale podla "Self-tuning PID Controllers 2004" Usually a = 10 is selected which means that the D-component filter has a time constant ten times smaller than the derivative time constant.
	 RVkc*(+1.0+(RVts/(2.0*RVti))+(2.0*RVtd/alfav)), 																									// k0 value for PID controller
	 RVkc*(RVts*RVts/RVti-4.0*RVk_lpf-4.0*RVtd)/alfav, 																								// k1 value for PID controller
	 ((2.0*RVk_lpf-RVts+RVts*RVts/(2.0*RVti))+(2.0*RVtd-RVk_lpf*RVts/RVti))*(RVkc/alfav),							// k2 value for PID controller - Bola tu chyba !!! p->k2 += 2.0 * p->ti - p->k_lpf * p->ts / p->ti;
	 0.0,																																															// k3 value for PID controller
	 4.0*RVk_lpf/alfav,																																								// value for LPF filter
	 (RVts-2.0*RVk_lpf)/alfav, 																																				// value for LPF filter
	 RVts*1000,																																												// ticks for timer
	 1,																																																// PID Controller type [0..3]
	 0.0, 																																														// debug
	 0.0, 																																														// debug
	 0.0, 																																														// debug
	 0.0,																																															// Temporary value for WinDup
   50.0,																																														// Ziadana hodnota teploty ...
	 0,0,0,																																														// SetPosition,ActualPosition,dPosition;
   RegVSrvMin,RegVSrvMax,0,RegVSrvHyster,																														
	 25,23,2,50,65,95,																																								// Tkomfort,Tutlm,deltaT,Tmin,Tmax,Tlimit;
	 AntiWin,																																													// Obmedzenie narastu vystupnej hodnoty regulatora v % pri prepnuti ziadanej hodnoty ....
	 0,																																																// Ekvitermicka - vykurovacia krivka ...
 }
};